PROGRAM mkPOSCAR
  USE defs
  USE struct
  USE latgen2
  USE constants
  IMPLICIT NONE
  CHARACTER(80)            :: deffn, errfn,peffn
  INTEGER                  :: iproc,i,j,jneq,jmult,index
  REAL(8)                  :: av(3)
  character(1)             :: lattice
  CALL gtfnam(deffn,errfn,iproc)
  peffn=deffn(1:LEN_TRIM(deffn))//".struct"
  OPEN (20,FILE=peffn,STATUS='OLD')
  CALL init_struct
  av(1)=aa;av(2)=bb;av(3)=cc
  ALPHA(1:3)=ALPHA(1:3)*PI/180.0D0
  SELECT CASE (LATTIC(1:1))
  CASE ('H','P')       !.....Primitive lattices
     lattice='P'
  CASE ( 'F')
     lattice='F'
  CASE ( 'B' )
     lattice='I'
  CASE( 'C' )
     SELECT CASE (lattic(2:3))
     CASE ( 'XY' )
        lattice='C'
     CASE( 'XZ ' )
        lattice='B'
     CASE( 'YZ' )
        lattice='A'
     END SELECT
  CASE ( 'R' )
     STOP 'SPECIAL TREATMENT NOT IMPLEMETED'
  CASE DEFAULT
     STOP 'LATGEN - Wrong lattice'
  END SELECT
  CALL init_latgen('xayb',lattice,av,alpha,0)
  OPEN(1,FILE='POSCAR')
  WRITE(1,'(A20)') title
  WRITE(1,'(f10.3)') -volume
! print transposed
  DO j=1,3
     WRITE(1,'(3f10.6)') (br1_dir(i,j)*A0_SI*1D10,i=1,3)
  ENDDO
  WRITE(1,'(100I3)') mult(1:nat)
  WRITE(1,'(A)') 'Direct'
  index = 0
  DO jneq=1,nat
     DO jmult = 1,mult(jneq)
        index=index+1
        WRITE(1,'(3f10.7,i5)') pos(1:3,index),zz(jneq)
     ENDDO
  ENDDO

END PROGRAM mkPOSCAR
